<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_SpecialSupplementType ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_SpecialSupplementType extends AbstractStructArrayBase
{
    /**
     * The SpecialSupplementType
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_SpecialSupplementType[]
     */
    public $SpecialSupplementType;
    /**
     * Constructor method for ArrayOfJP_SpecialSupplementType
     * @uses ArrayOfJP_SpecialSupplementType::setSpecialSupplementType()
     * @param \StructType\JP_SpecialSupplementType[] $specialSupplementType
     */
    public function __construct(array $specialSupplementType = array())
    {
        $this
            ->setSpecialSupplementType($specialSupplementType);
    }
    /**
     * Get SpecialSupplementType value
     * @return \StructType\JP_SpecialSupplementType[]|null
     */
    public function getSpecialSupplementType()
    {
        return $this->SpecialSupplementType;
    }
    /**
     * Set SpecialSupplementType value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_SpecialSupplementType[] $specialSupplementType
     * @return \ArrayType\ArrayOfJP_SpecialSupplementType
     */
    public function setSpecialSupplementType(array $specialSupplementType = array())
    {
        foreach ($specialSupplementType as $arrayOfJP_SpecialSupplementTypeSpecialSupplementTypeItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_SpecialSupplementTypeSpecialSupplementTypeItem instanceof \StructType\JP_SpecialSupplementType) {
                throw new \InvalidArgumentException(sprintf('The SpecialSupplementType property can only contain items of \StructType\JP_SpecialSupplementType, "%s" given', is_object($arrayOfJP_SpecialSupplementTypeSpecialSupplementTypeItem) ? get_class($arrayOfJP_SpecialSupplementTypeSpecialSupplementTypeItem) : gettype($arrayOfJP_SpecialSupplementTypeSpecialSupplementTypeItem)), __LINE__);
            }
        }
        $this->SpecialSupplementType = $specialSupplementType;
        return $this;
    }
    /**
     * Add item to SpecialSupplementType value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_SpecialSupplementType $item
     * @return \ArrayType\ArrayOfJP_SpecialSupplementType
     */
    public function addToSpecialSupplementType(\StructType\JP_SpecialSupplementType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_SpecialSupplementType) {
            throw new \InvalidArgumentException(sprintf('The SpecialSupplementType property can only contain items of \StructType\JP_SpecialSupplementType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->SpecialSupplementType[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_SpecialSupplementType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_SpecialSupplementType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_SpecialSupplementType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_SpecialSupplementType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_SpecialSupplementType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SpecialSupplementType
     */
    public function getAttributeName()
    {
        return 'SpecialSupplementType';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_SpecialSupplementType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
